## txt2regex 0.7

=== Makefile ===
NAME = txt2regex
VERSION	= 0.7

SHSKEL = $(NAME)-$(VERSION).sh
DISTDIR = $(NAME)-$(VERSION)
PODIR = po
TESTDIR = test-suite

FILES = Makefile README README.japanese NEWS Changelog COPYRIGHT TODO $(SHSKEL) $(PODIR) tools $(TESTDIR) $(NAME).man 


DESTDIR = 
BINDIR	= $(DESTDIR)/usr/bin
LOCALEDIR = $(DESTDIR)/usr/share/locale
MANDIR = $(DESTDIR)/usr/share/man/man1

TARGET=all

clean:
	rm -f {,po/}messages po/*.{mo,old,tmp,bk} test-suite/javascript.html $(NAME)
	find po -mindepth 1 -type d -exec rm -rf {} \;

check-po-dir: 
	@if [ ! -d $(PODIR) ]; then \
	echo "warning: directory '$(PODIR)' not found. nothing to do."; \
	exit 1;\
	fi

# shit, bash <<-HEREDOC seems to doesn't work inside Makefile...
pot: check-po-dir
	@cd $(PODIR); \
	DATE=`date '+%Y-%m-%d %H:%M %Z'`;\
	echo '#, fuzzy'                                          > $(NAME).pot.tmp;\
	echo 'msgid ""'                                         >> $(NAME).pot.tmp;\
	echo 'msgstr ""'                                        >> $(NAME).pot.tmp;\
	echo '"Project-Id-Version: $(NAME) $(VERSION)\n"'       >> $(NAME).pot.tmp;\
	echo "\"POT-Creation-Date: $$DATE\n\""                  >> $(NAME).pot.tmp;\
	echo '"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"'      >> $(NAME).pot.tmp;\
	echo '"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"'   >> $(NAME).pot.tmp;\
	echo '"Language-Team: LANGUAGE <LL@li.org>\n"'          >> $(NAME).pot.tmp;\
	echo '"MIME-Version: 1.0\n"'                            >> $(NAME).pot.tmp;\
	echo '"Content-Type: text/plain; charset=iso-8859-1\n"' >> $(NAME).pot.tmp;\
	echo '"Content-Transfer-Encoding: 8bit\n"'              >> $(NAME).pot.tmp;\
	bash --dump-po-strings ../$(SHSKEL)                     >> $(NAME).pot.tmp;\
	../tools/bashdump-rmdup.sh $(NAME).pot.tmp               > $(NAME).pot;\
	grep '##duplicated##'                                      $(NAME).pot;

po: check-po-dir
	@cd $(PODIR) && \
	for pot in *.po; do \
		echo -n "merging $$pot..."; \
		poti=`echo $$pot | sed 's/\.po$$//'`; \
		cp $$pot $$pot.old && \
		msgmerge $$pot.old $(NAME).pot > $$pot; \
	done

mo: check-po-dir
	@cd $(PODIR) && \
	for pot in *.po; do \
		echo -n "compiling $$pot..."; \
		poti=`echo $$pot | sed 's/\.po$$//'`; \
		msgfmt -o $$poti.mo $$pot && \
		echo ok; \
	done

check-po: check-po-dir
	@cd $(PODIR) && \
	for pot in *.po; do \
		echo -n "checking $$pot... "; \
		msgfmt -v $$pot || exit 1; \
	done

update-po: pot po mo


tgz: clean #check-po
	mkdir $(DISTDIR) && \
	cp -a $(FILES) $(DISTDIR) && \
	tar cvzf $(DISTDIR).tgz $(DISTDIR) && \
	rm -rf $(DISTDIR)

# just once: COPYRIGHT tools linuxformat.png old screenshot.png
upload:
	scp -r `echo $(FILES) | sed 's/COPYRIGHT\|tools\|test-suite//g'` index.html $(DISTDIR).tgz \
	  verde666@$(NAME).sf.net:/home/groups/t/tx/$(NAME)/htdocs

#TODO install man page and README
install: mo
	@[ -d $(LOCALEDIR) ] || mkdir -p $(LOCALEDIR); \
	[ -d $(BINDIR) ] || mkdir -p $(BINDIR); \
	for pot in `cd $(PODIR) && ls *.mo`; do \
		poti=`echo $$pot | sed 's/\.mo$$//'`; \
		modir=$(LOCALEDIR)/$$poti/LC_MESSAGES; \
		[ -d $$modir ] || mkdir -p $$modir; \
		install -m644 $(PODIR)/$$pot $$modir/$(NAME).mo; \
	done; \
	sed -e '/^TEXTDOMAINDIR=/s,=.*,=$(LOCALEDIR),' \
	    -e '/^VERSION=/s/=.*/=$(VERSION)/' $(SHSKEL) > $(BINDIR)/$(NAME) && \
	chmod +x $(BINDIR)/$(NAME) && \
	echo "program '$(NAME)' installed. just run $(BINDIR)/$(NAME)"

###DEVELOPPER ONLY###	
doc:
	@txt2tags -t man --stdout README.txt > $(NAME).man; \
	txt2tags  -t txt --stdout README.txt > README; \
	txt2tags -t html --stdout README.txt > README.html
# got interested? http://txt2tags.sf.net
###---###

## txt2regex 0.9

=== Makefile ===
NAME = txt2regex
VERSION = 0.9
BASHVERSIONS = 3.0 3.1 3.2 4.0 4.1 4.2 4.3 4.4 5.0
REGEXTESTERIMAGE = aureliojargas/regex-tester:2020-05-09

SCRIPT = $(NAME).sh
PODIR = po
POTFILE = $(PODIR)/$(NAME).pot

DESTDIR =
BINDIR = $(DESTDIR)/usr/bin
LOCALEDIR = $(DESTDIR)/usr/share/locale
MANDIR = $(DESTDIR)/usr/share/man/man1

.PHONY: check check-po clean doc fmt install install-bin \
        install-mo lint mo po pot test test-bash test-regex \
        test-regex-build test-regex-shell

#-----------------------------------------------------------------------
# Dev

check: lint test

fmt:
	shfmt -w -i 4 -ci -sr $(SCRIPT) tests/regex-tester.sh

lint:
	shellcheck $(SCRIPT) tests/regex-tester.sh
	shfmt -d -i 4 -ci -sr $(SCRIPT) tests/regex-tester.sh

test: clitest.sh
	sh clitest.sh --progress none README.md tests/*.md

# Run the tests in multiple Bash versions, using the official Docker
# image https://hub.docker.com/_/bash (each image is ~10MB)
test-bash: clitest.sh
	@for v in $(BASHVERSIONS); do \
		printf '\nTesting in Bash version %s\n' $$v; \
		docker run --rm -v $$PWD:/code -w /code bash:$$v \
			sh clitest.sh --progress none tests/*.md; \
	done

# Run regex tests for the supported programs, inside a Docker container
test-regex:
	# Explicit pull to make sure all the log messages from the pulling
	# process appear here, and not when executing the next "docker run",
	# whose output goes directly to the .txt file.
	docker image inspect $(REGEXTESTERIMAGE) >/dev/null 2>&1 || \
	docker pull $(REGEXTESTERIMAGE)

	# Test all programs except "vi"
	docker run --rm -v "$$PWD":/code -w /code $(REGEXTESTERIMAGE) \
		tests/regex-tester.sh --skip vi > tests/regex-tester.txt 2>&1

	# vi: no stderr redirect to avoid "inappropriate ioctl for device"
	# vi: docker run -t adds a trailing \r to every line :/
	docker run --rm -v "$$PWD":/code -w /code -t $(REGEXTESTERIMAGE) \
		tests/regex-tester.sh vi | tr -d '\r' >> tests/regex-tester.txt

test-regex-shell:
	docker run --rm -v "$$PWD":/code -w /code -it $(REGEXTESTERIMAGE)

test-regex-build:
	docker build -t $(REGEXTESTERIMAGE) tests/

clean:
	rm -f clitest.sh $(NAME) txt2tags.py
	rm -f messages.mo $(PODIR)/{messages,*.mo,*.tmp,*~}
	rm -rf $(PODIR)/??/ $(PODIR)/??_??/
	rm -f tmp.lex.*.{l,run,yy.c}

doc: txt2tags.py
	python ./txt2tags.py -t man  man/txt2regex.t2t
	python ./txt2tags.py -t html man/txt2regex.t2t

clitest.sh:
	curl -s -L -o $@ \
	https://raw.githubusercontent.com/aureliojargas/clitest/master/clitest

txt2tags.py:
	curl -s -L -o $@ \
	https://raw.githubusercontent.com/aureliojargas/txt2tags/3.4/txt2tags.py

#-----------------------------------------------------------------------
# Translation files
#
# Learn more: http://pology.nedohodnik.net/doc/user/en_US/ch-poformat.html
# Example potfile: http://git.savannah.gnu.org/cgit/gawk.git/tree/po/gawk.pot

pot:
	@date=`date '+%Y-%m-%d %H:%M %Z'`; \
	( \
		printf '%s\n' '#, fuzzy'; \
		printf '%s\n' 'msgid ""'; \
		printf '%s\n' 'msgstr ""'; \
		printf '"%s"\n' 'Project-Id-Version: $(NAME) $(VERSION)\n'; \
		printf '"%s"\n' "POT-Creation-Date: $$date\n"; \
		printf '"%s"\n' 'PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n'; \
		printf '"%s"\n' 'Last-Translator: FULL NAME <EMAIL@ADDRESS>\n'; \
		printf '"%s"\n' 'MIME-Version: 1.0\n'; \
		printf '"%s"\n' 'Content-Type: text/plain; charset=UTF-8\n'; \
		printf '"%s"\n' 'Content-Transfer-Encoding: 8bit\n'; \
		bash --dump-po-strings $(SCRIPT); \
	) | msguniq --no-wrap --sort-by-file -o $(POTFILE); \
	printf '%s was generated\n' $(POTFILE)

po: pot
	@for pofile in $(PODIR)/*.po; do \
		printf 'Merging %s...' $$pofile; \
		msgmerge --update --sort-by-file --no-wrap --previous \
			$$pofile $(POTFILE); \
	done; \
	printf 'Remember to grep for the fuzzy messages in all .po files\n'

mo:
	@for pofile in $(PODIR)/*.po; do \
		printf 'Compiling %s... ' $$pofile; \
		msgfmt -o $${pofile%.po}.mo $$pofile && \
		echo ok; \
	done

check-po:
	@for pofile in $(PODIR)/*.po; do \
		printf 'Checking %s...' $$pofile; \
		msgfmt --verbose $$pofile || exit 1; \
	done

#-----------------------------------------------------------------------
# Release

install: install-mo install-bin

install-mo: mo
	test -d $(LOCALEDIR) || mkdir -p $(LOCALEDIR); \
	for mofile in $(PODIR)/*.mo; do \
		moinstalldir=$(LOCALEDIR)/`basename $$mofile .mo`/LC_MESSAGES; \
		test -d $$moinstalldir || mkdir -p $$moinstalldir; \
		install -m644 $$mofile $$moinstalldir/$(NAME).mo; \
	done

install-bin:
	test -d $(BINDIR) || mkdir -p $(BINDIR); \
	sed -e '/^TEXTDOMAINDIR=/s,=.*,=$(LOCALEDIR),' \
		$(SCRIPT) > $(BINDIR)/$(NAME) && \
	chmod +x $(BINDIR)/$(NAME) && \
	printf '\nProgram "%s" installed. Just run %s\n' \
		$(NAME) $(BINDIR)/$(NAME)

=== debian/changelog ===
txt2regex (0.9-3) unstable; urgency=medium

  * actually test /usr/bin/txt2regex in autopkgtest...

 -- Rene Engelhard <rene@debian.org>  Sun, 27 Sep 2020 15:59:51 +0000

txt2regex (0.9-2) unstable; urgency=medium

  * run make test also during the build; make autopkgtest use make test, too 

 -- Rene Engelhard <rene@debian.org>  Sun, 27 Sep 2020 14:26:41 +0200

txt2regex (0.9-1) unstable; urgency=medium

  * "New" upstream release
    - no "stay tunned" in manpage anymore for --history (closes: #309890)

  * move to 3.0 (quilt) instead of dpatch (closes: #668653)
  * add autopkgtests
  * run make doc
  * fix typo in de_DE.po (s/einmmal/einmal/) (closes: #618860)

 -- Rene Engelhard <rene@debian.org>  Sun, 27 Sep 2020 13:47:14 +0200

txt2regex (0.8-5) unstable; urgency=medium

  * bump dh compat to 9; dh_clean -k -> dh_prep
  * update watch for github (closes: #529150) and add Homepage: 

 -- Rene Engelhard <rene@debian.org>  Thu, 07 Jul 2016 11:39:54 +0200

txt2regex (0.8-4) unstable; urgency=low

  * fix 02_add_fr_FR.po.dpatch and 03_add_ca.po.dpatch to apply
    correctly (closes: #608209)
  * fix lintian stuff
    - s/Build-Depends-Indep/Build-Depends/ 
    - update menu for "new" menu sections 
    - add ${misc:Depends}
    - recode copyright to UTF-8

 -- Rene Engelhard <rene@debian.org>  Tue, 28 Dec 2010 22:41:29 +0100

txt2regex (0.8-3) unstable; urgency=low

  * fix for bash 3.1, thanks Mike O'Connor (closes: #346226)

 -- Rene Engelhard <rene@debian.org>  Mon, 23 Jan 2006 23:17:55 +0100

txt2regex (0.8-2) unstable; urgency=low

  * upload non-native, oops 

 -- Rene Engelhard <rene@debian.org>  Tue, 18 Jan 2005 01:29:16 +0100

txt2regex (0.8-1) unstable; urgency=low

  * New upstream release. (closes: #273965)
  * add fr_FR and ca pos from upstream site 

 -- Rene Engelhard <rene@debian.org>  Mon, 17 Jan 2005 16:27:56 +0100

txt2regex (0.7-10) unstable; urgency=high

  * remove strace output file which accidentially went into the
    diff *sigh*

 -- Rene Engelhard <rene@debian.org>  Thu,  5 Aug 2004 01:55:48 +0200

txt2regex (0.7-9) unstable; urgency=low

  * fix $BASH_VERSION check to accept bash 3.x (closes: #262762) 

 -- Rene Engelhard <rene@debian.org>  Tue,  3 Aug 2004 15:20:15 +0200

txt2regex (0.7-8) unstable; urgency=low

  * add es_ES.po and ro_RO.po from upstream 
  * Standards-Version: 3.6.1 (no changes needed)
  * quote stuff in menu file
  * fix clean

 -- Rene Engelhard <rene@debian.org>  Sat,  3 Jul 2004 17:05:43 +0200

txt2regex (0.7-7) unstable; urgency=low

  * add it_IT.po from upstream 

 -- Rene Engelhard <rene@debian.org>  Wed,  3 Mar 2004 04:53:28 +0100

txt2regex (0.7-6) unstable; urgency=low

  * s/Author\(s\)/Author/ in debian/copyright 

 -- Rene Engelhard <rene@debian.org>  Thu, 24 Apr 2003 00:40:45 +0200

txt2regex (0.7-5) unstable; urgency=low

  * fix manpage (closes: #190304) 
  * move to dpatch, existing change splut out into 01_makefile_fixes,
    new: 02_fix_manpage
  * debhelper compat v4; Standards-Version: 3.5.9

 -- Rene Engelhard <rene@debian.org>  Wed, 23 Apr 2003 16:55:56 +0200

txt2regex (0.7-4) unstable; urgency=low

  * new maintainer (closes: #158520) 

 -- Rene Engelhard <rene@debian.org>  Wed, 28 Aug 2002 16:35:48 +0200

txt2regex (0.7-3) unstable; urgency=low

  * Fixed typo

 -- Martin Butterweck <blendi@debian.org>  Sat, 13 Apr 2002 04:37:55 +0200

txt2regex (0.7-2) unstable; urgency=low

  * Fixed locale files
  closes: #138494

 -- Martin Butterweck <blendi@debian.org>  Wed,  3 Apr 2002 13:23:34 +0200

txt2regex (0.7-1) unstable; urgency=low

  * New upstream release
  closes: #128519 #129397
  * Changed build-deps
  closes: #134939
 
 -- Martin Butterweck <blendi@debian.org>  Wed,  6 Mar 2002 14:15:25 +0100

txt2regex (0.6-2) unstable; urgency=low

  * Changed TEXTDOMAINDIR to point to correct location
  * Added undocumented(7) manpage link

 -- Martin Butterweck <blendi@debian.org>  Sat, 26 Jan 2002 15:41:24 +0100

txt2regex (0.6-1) unstable; urgency=low

  * Initial Release.
  closes: #128427
 -- Martin Butterweck <blendi@debian.org>  Wed,  9 Jan 2002 13:58:19 +0100

=== debian/control ===
Source: txt2regex
Section: utils
Priority: optional
Maintainer: Rene Engelhard <rene@debian.org>
Build-Depends: debhelper (>> 9), gettext, txt2tags, clitest <!nocheck>
Standards-Version: 3.6.1
Homepage: https://github.com/aureliojargas/txt2regex

Package: txt2regex
Architecture: all
Depends: bash (>> 3.0), ${misc:Depends}
Description: A Regular Expression "wizard", all written with bash2 builtins
 ^txt2regex$ is a Regular Expression "wizard", all written with bash2
 builtins, that converts human sentences to RegExs. With a simple
 interface, you just answer to questions and build your own RegEx for a
 large variety of programs, like awk, emacs, grep, perl, php, procmail,
 python, sed and vim. There are more than 20 supported programs.

=== debian/rules ===
#!/usr/bin/make -f

configure: configure-stamp
configure-stamp:
	touch configure-stamp

build: build-stamp

build-stamp: configure-stamp 
	$(MAKE) doc
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	-$(MAKE) clean
	rm -f po/*.mo
	rm -f tmp.lex.1*
	rm -f man/txt2regex.html man/txt2regex.man	

	dh_clean

test:
ifneq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) test
endif

install: build test
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	
	$(MAKE) install DESTDIR=$(CURDIR)/debian/txt2regex


binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installmenu
	dh_installchangelogs CHANGELOG.md
	dh_installman man/txt2regex.man
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-arch: build install

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/txt2regex-$1\.tar\.gz/ \
  https://github.com/aureliojargas/txt2regex/tags .*/v?(\d\S*)\.tar\.gz
